package org.example;

import org.objectweb.asm.ClassWriter;
import org.objectweb.asm.MethodVisitor;
import org.objectweb.asm.Opcodes;
import java.io.FileOutputStream;
import java.io.IOException;

public class Main implements Opcodes {

    public static void main(String[] args) throws IOException {

        ClassWriter classWriter = new ClassWriter(ClassWriter.COMPUTE_FRAMES | ClassWriter.COMPUTE_MAXS);


        classWriter.visit(V1_8, ACC_PUBLIC, "Foo", null, "java/lang/Object", null);


        MethodVisitor constructor = classWriter.visitMethod(ACC_PUBLIC, "<init>", "()V", null, null);
        constructor.visitCode();
        constructor.visitVarInsn(ALOAD, 0);
        constructor.visitMethodInsn(INVOKESPECIAL, "java/lang/Object", "<init>", "()V", false);
        constructor.visitInsn(RETURN);
        constructor.visitMaxs(0, 0);
        constructor.visitEnd();

        MethodVisitor bridgeHashCodeMethod = classWriter.visitMethod(ACC_PUBLIC | ACC_BRIDGE | ACC_SYNTHETIC, "hashCode", "()I", null, null);
        bridgeHashCodeMethod.visitCode();
//        bridgeHashCodeMethod.visitVarInsn(ALOAD, 0);
//        bridgeHashCodeMethod.visitMethodInsn(INVOKEVIRTUAL, "Foo", "hashCode", "()Ljava/lang/Integer;", false);
//        bridgeHashCodeMethod.visitMethodInsn(INVOKEVIRTUAL, "java/lang/Integer", "intValue", "()I", false);
        bridgeHashCodeMethod.visitLdcInsn(24);
        bridgeHashCodeMethod.visitInsn(IRETURN);
        bridgeHashCodeMethod.visitMaxs(0, 0);
        bridgeHashCodeMethod.visitEnd();

        MethodVisitor hashCodeMethod = classWriter.visitMethod(ACC_PUBLIC, "hashCode", "()Ljava/lang/Integer;", null, null);
        hashCodeMethod.visitCode();
        hashCodeMethod.visitLdcInsn(42);
        hashCodeMethod.visitMethodInsn(INVOKESTATIC, "java/lang/Integer", "valueOf", "(I)Ljava/lang/Integer;", false);
        hashCodeMethod.visitInsn(ARETURN);
        hashCodeMethod.visitMaxs(0, 0);
        hashCodeMethod.visitEnd();

        classWriter.visitEnd();

        byte[] classBytes = classWriter.toByteArray();

        try (FileOutputStream fos = new FileOutputStream("Foo.class")) {
            fos.write(classBytes);
        }
    }
}
